:- module(prelude, [predefineds/0, forbidden/1]).

:- use_module(symtab, [add_rule/2, add_constructor/2, set_object_property/3] ).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Predefinidos %%%%%%%%%%%%%%%%

:- dynamic builtin/1.

forbidden(F) :-
	builtin(F).
%	member(F,[eq,req,and_bool,or_bool,goal,ord,chr,getChar,putChar,constraint,apply_list,done,return]),!.

create_type(Name, Arity, ConsL) :-
	create_cons(Name, ConsL),
	set_object_property(Name, arity, Arity).

create_cons(_, []).
create_cons(Type, [(CName, CArity, CType)|R]) :-
	add_constructor(Type, CName),
	set_object_property(CName, type, CType),
	set_object_property(CName, arity, CArity),
	set_object_property(CName, constructs, Type),

	create_cons(Type, R).
	
create_builtin(Name, Type) :-
	add_rule(Name, builtin),
	set_object_property(Name, type, Type),
	assert(builtin(Name)).

predefineds :-

	% !!!! Hack hack ugly hack
	assert(builtin('@Objective')),

	create_type(list, 1, [([], 0, list(_)),
	                      ('.', 2, (A -> list(A) -> list(A))),
			      (':', 2, (A -> list(A) -> list(A))) ]),
        
        create_type(tuple, 2, [(',', 2, (_ -> _ -> tuple(_))) ] ),
	
	create_type('Bool', 0, [('True', 0, 'Bool'), ('False', 0, 'Bool')]),
	
	create_type('Int', 0, []),

	create_type('Constraint', 1, []), 
	
	create_builtin('+', ('Int'->'Int'->'Int')),
	create_builtin('-', ('Int'->'Int'->'Int')),
	create_builtin('*', ('Int'->'Int'->'Int')),
	create_builtin('/', ('Float'->'Float'->'Float')),

 	create_builtin('==', (A -> A -> 'Bool')),
	
	create_builtin('ifthenelse', ('Bool'->A->A->A)).


% 	create_builtin('mod', ('Int'->'Int'->'Int')),
% 	create_builtin('div', ('Int'->'Int'->'Int')),
% 	create_builtin('=',  (A->A->'Constraint')),
% 	create_builtin('<>', (A->A->'Bool')),
% 						% Arithmetic comparison
% 	create_builtin('<',  ('Int'->'Int'->'Bool')),
% 	create_builtin('>',  ('Int'->'Int'->'Bool')),
% 	create_builtin('=<', ('Int'->'Int'->'Bool')),
% 	create_builtin('>=', ('Int'->'Int'->'Bool')),
% 						% boolean functions
% 	create_builtin('&&', ('Bool'->'Bool'->'Bool')),
% 	create_builtin('||', ('Bool'->'Bool'->'Bool')).
						% Misc Objects
						%		create('@Objective',objective),

% This should be done with type classes.

%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

